﻿namespace DataSharing.Share.Dtos.HotlineWeb
{
    public class CalculateUploadRateDto
    {

        /// <summary>
        /// 工单总量
        /// </summary>
        public int OrderCountNum { get; set; }

        /// <summary>
        /// 工单及时上传
        /// </summary>
        public int OrderTimely { get; set; }

        /// <summary>
        /// 工单未及时上传
        /// </summary>
        public int OrderNotTimely { get; set; }

        /// <summary>
        /// 工单及时率
        /// </summary>
        public double OrderTimelinessRate => CalcOrderTimelinessRate();

        public double CalcOrderTimelinessRate()
        {
            if (OrderTimely != 0 && OrderCountNum != 0)
            {
                return Math.Round((OrderTimely / (double)OrderCountNum) * 100, 2);
            }
            return 0;
        }


        /// <summary>
        /// 电话总量
        /// </summary>
        public int TelCountNum { get; set; }

        /// <summary>
        /// 电话及时上传
        /// </summary>
        public int TelTimely { get; set; }

        /// <summary>
        /// 电话未及时上传
        /// </summary>
        public int TelNotTimely { get; set; }

        /// <summary>
        /// 电话及时率
        /// </summary>
        public double TelTimelinessRate => CalcTelTimelinessRate();

        public double CalcTelTimelinessRate()
        {
            if (TelCountNum != 0 && TelTimely != 0)
            {
                return Math.Round((TelTimely / (double)TelCountNum) * 100, 2);
            }
            return 0;
        }


        /// <summary>
        /// 电话来源工单数量
        /// </summary>
        public int RGDHOrderCount { get; set; }

        /// <summary>
        /// 匹配通话记录数
        /// </summary>
        public int ContainTel { get; set; }

        /// <summary>
        /// 未匹配通话记录数
        /// </summary>
        public int NotContainTel { get; set; }

        /// <summary>
        /// 匹配率
        /// </summary>
        public double MatchingRate => CalcMatchingRate();

        public double CalcMatchingRate()
        {
            if (ContainTel != 0 && RGDHOrderCount != 0)
            {
                return Math.Round((ContainTel / (double)RGDHOrderCount) * 100, 2);
            }
            return 0;
        }
    }
}
